/*
 * Created on 18/07/2004
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.test;

import il.ac.technion.cs.course236308.e3.med.command.test.version.TestVersionUpdateWeight;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestVersionsFactory;

/**
 * @author shralex
 */
public class TestSetVersionWeight extends CommandAction {

    private int testId;
    private int verId;
    private Double weight;
    public TestSetVersionWeight (int testId, int verId,Double weight, MainWindow frame) {
        super("TestVersion Set weight");
        putValue(SHORT_DESCRIPTION, "TestVersion Set weight");
        init(frame);
        this.testId = testId;
        this.verId = verId;
        this.weight = weight;
    } 
    
    public void execute() throws RetriableException, CriticalException {
    	TestVersion tv = TestVersionsFactory.getInstance().getTestVersion(testId,verId);
        runCommand(new TestVersionUpdateWeight(tv, weight)); 
    }   

}
