/*
 * Created on 18/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.db.queries.grading;

import il.ac.technion.cs.course236308.e3.med.db.Query;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Test;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class PercentTestAnswerOfTakers extends Query {
	/**
	 * Percent of student who choosed Test Answer 
	 * out of all Test Takers in the given Test.
	 * @param test
	 * @param ans
	 */
	public PercentTestAnswerOfTakers(Test test,Answer ans) {
		super("SELECT " +
				"(SELECT count(ExamTakerID) FROM  " +
					"(Select distinct ExamTakerID" +
						" from ExamReplies er" +
						" WHERE er.AnswerID=" + ans.getId()+
						" AND ExamID=" +test.getId()+"))" +
            	"/ count( ExamTakerID)" +
			  "FROM" +
				" (select distinct ExamTakerID" +
				" from ExamReplies" +
				" WHERE ExamID = " +test.getId() +")");
	}
}
