/*
 * Created on 18/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.db.queries.version;

import java.text.SimpleDateFormat;

import il.ac.technion.cs.course236308.e3.med.db.Query;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class UpdateVersion extends Query {
	/**
	 * Method UpdateVersion
	 * @param ver
	 */
	public UpdateVersion(Version ver) {
		super("Update Version set CorrectAnswerId=" + ver.getCorrectAnswerId() +
				",Body="     +quote(ver.getBody()) +
				",Language=" +quote(ver.getLanguage()) +
				",Notes="    +quote(ver.getNotes()) + 
				",Updated="  +quote(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").
							  format(ver.getUpdated().getTime())) +
				",AvgDifficulty="+ ver.getAvgDifficulty() + 
				",AvgDI="        + ver.getAvgDI()  +
				" where ID="     + ver.getId());
	}
}
