package il.ac.technion.cs.course236308.e3.med.gui.datamodels;
import il.ac.technion.cs.course236308.e3.med.gui.panels.RepliesTable;
import il.ac.technion.cs.course236308.e3.med.parameters.*;
import java.awt.Color;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableCellRenderer;
/*
 * Created on Apr 19, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

/**
 * @author Dmitry
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ReplyTableCellRenderer extends DefaultTableCellRenderer /*implements TableCellRenderer*/ {

	
	JTextField tf = new JTextField();
	JLabel l  = new JLabel();
	Color black1 = new Color(162,162,162); 
	Color black2 = new Color(162,162,162+20); 

	Color white1 = new Color(255,255,255); 
	Color white2 = new Color(255-20,255-20,255); 
		
	public Component getTableCellRendererComponent(JTable table, 
		Object value, 
		boolean isSelected,
		boolean isFucused, 
		int row, 
		int column) {
		
		
		if (column < 2 || column > 1 + RepliesTable.ANSWERS_NUM ){
			if ( row >= RepliesTable.QUESTION_NUM)
				return  super.getTableCellRendererComponent(table, value,false,false,row,column);
			return super.getTableCellRendererComponent(table, value,isSelected,false,row,column);
		}
			
		l.setOpaque(true);
		
		if ( RepliesTable.QUESTION_NUM  <= row ){
			
			tf.setText("" + table.getValueAt(row,column));
			
			if ((row)%2 == 1){
					tf.setBackground(Color.lightGray);
			}
			else{
				tf.setBackground(Color.white);
			}
	
			return tf;
		}
		
		l.setText("" + (char)('A'+ (column - 2)));
		l.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		
		if (value == null)
			l.setIcon(GeneralParams.ICON_UNCHECKED);
		
		else if (  (  (Boolean)table.getValueAt(row,column)).booleanValue() ){
			l.setIcon(GeneralParams.ICON_CHECKED);
			l.setBackground(Color.PINK);
		}
		else{
			l.setIcon(GeneralParams.ICON_UNCHECKED);
			if (!GeneralParams.isGreyField(row,column-2)){
				if (isSelected){
					l.setBackground(black2);
				}
				else
					l.setBackground(black1);
			}
			else{
				if (isSelected){
					//l.setBackground(Color.lightGray);
					l.setBackground(white2);
				}else{
					l.setBackground(white1);
				}
			}
		}
		l.setBorder(BorderFactory.createEmptyBorder());
					
		return l;
	}


}
