package il.ac.technion.cs.course236308.e3.med.model;

import il.ac.technion.cs.course236308.e3.med.parameters.TestParams;

import java.util.Hashtable;
import java.util.List;
import java.util.ListIterator;

public class StudentReply implements Comparable{
	/**
	 * @param id
	 */
	public StudentReply(String id) {
		answers = new Hashtable();
		studentId = id;
		studentName = "";
	}

    private String studentId;
	private long rid;
	private String studentName;
	private Hashtable answers; // question(Integer)=> answer(Integer)
	
    public StudentReply(long rid){
            answers = new Hashtable();
            studentName = "";
            studentId = "";
            this.rid = rid;
        }

    public StudentReply(){
		answers = new Hashtable();
		studentName = "";
    }
	public StudentReply(String sId,long rId){
		studentId = sId;
		rid = rId;
		studentName = "";
		answers = new Hashtable();
		// Now we fill the answers Hash calling functions from DBConnect
		
	}
  	public void setStudentName(String name){
  		studentName = name;
  	}
  	public String getStudentName(){
  		return studentName;
  	}
  
	public int compareTo(Object obj){
		StudentReply other = (StudentReply)obj;
        
        if (studentId.equals(other.studentId) )
            return 0;
        return 1;
	}
	
		
	
	
	
	
	public String toString(){
		return "" + rid;
/*		String string = new String("Id:");
		string = string + studentId + "\nRID:";
		string = string + rid + "\n";
		
		
		Enumeration enum = answers.keys();
		while (enum.hasMoreElements()){
			Integer question = (Integer)enum.nextElement();
			string +="\t";
			string += question;
			string +="\t";
			string += (Integer)answers.get(question);
			string +="\n"; 
		}
		
		return string;
*/				
	} 
	
	public String getStudentId(){
		return studentId;
	}
	
	public Hashtable getAnswers(){
		return answers;
	}
	
	
	public long getRid() {
		return rid;		
	}
 

	/**
	 * Method setAnswers.
	 * @param answers
	 */
	public void setAnswers(Hashtable anAnswers) {
		answers = anAnswers;
	}


	/**
	 * @param rid
	 */
	public void setRID(long newRID) {
		rid = newRID;
	}


	/**
	 * 
	 */
	public void setID(String newID) {
		studentId = newID;
	}

   
    public void addAnswer(Integer question, Integer answer){
		answers.put(question, answer);
    }
    public void removeAnswer(Integer question){
    	answers.remove(question);
    }
////////////////////////////////////////////////////////////////////////////////////
	public int[] checkSumCalculate(Test test,char[] answersArray ){
			int sheetsNum = test.getTestVersions().size()/TestParams.ANSWERS_NUM_PER_SHEET+ 1;
		
			int maxAnswersNum = 0;
			List versions = test.getTestVersions();
			for (ListIterator i=versions.listIterator(); i.hasNext(); ) {
				TestVersion tv = (TestVersion) i.next();
				int currNum = tv.getTestAnswers().size();
				if(currNum > maxAnswersNum)
					maxAnswersNum = currNum;
			}
		
			maxAnswersNum ++ ; // add 'H' column
			int[] calcCheckSum = new 
						int[sheetsNum * maxAnswersNum * TestParams.CHECKSUM_ROWS_NUM];
			int index = 0;
		
			// for each sheet (luah)		
			for(int i = 0; i < sheetsNum; ++i){
				// get number of question on the sheet
				int sheetQuestionNum = TestParams.ANSWERS_NUM_PER_SHEET;			
				if(test.getTestVersions().size() - i*TestParams.ANSWERS_NUM_PER_SHEET <
				TestParams.ANSWERS_NUM_PER_SHEET){
					sheetQuestionNum = 
						test.getTestVersions().size() - i*TestParams.ANSWERS_NUM_PER_SHEET;
				}
							
				// get answers for the sheet
				char[] sheetAnswers = new char[sheetQuestionNum]; 
				for(int j = 0; j < sheetQuestionNum; ++j){
					sheetAnswers[j] = answersArray[i*TestParams.ANSWERS_NUM_PER_SHEET + j]; 
				}
			
				// fill checkSumArray for the sheet
				// a. create and initialize array for the sheet's checksums 
				int[][] sheetCheckSum = 
					new int[TestParams.CHECKSUM_ROWS_NUM][TestParams.ANSWERS_NUM_PER_SHEET];
				for(int j = 0; j < TestParams.CHECKSUM_ROWS_NUM; ++j)
					for(int k = 0; k < maxAnswersNum ; ++k)
						sheetCheckSum[j][k] = 0;
			
				// b. calculate white and grey checksums
				for(int j = 0; j < sheetQuestionNum; ++j){
					if(sheetAnswers[j] == 'X')
						continue;				
					if(isGreyField(j+1,sheetAnswers[j])){
						sheetCheckSum[1][getIndex(sheetAnswers[j]) + 1]++;
					}else{
						sheetCheckSum[0][getIndex(sheetAnswers[j]) + 1]++;
					}
				}
			
				// c. calculate third row checksum
				int whiteSum = 0;
				int greySum = 0;
				for(int j = 0; j < maxAnswersNum ; ++j){
					sheetCheckSum[2][j] = sheetCheckSum[0][j] + sheetCheckSum[1][j];
					whiteSum += sheetCheckSum[0][j];
					greySum += sheetCheckSum[1][j];
				}
				sheetCheckSum[0][0] = whiteSum;
				sheetCheckSum[1][0] = greySum;
				sheetCheckSum[2][0] = whiteSum + greySum;
			
				// d. write results to calcCheckSum
				for(int j = 0; j < maxAnswersNum ; ++j){
					calcCheckSum[index++] =  sheetCheckSum[0][j];
				}
				for(int j = 0; j < maxAnswersNum ; ++j){
					calcCheckSum[index++] =  sheetCheckSum[1][j];
				}
				for(int j = 0; j < maxAnswersNum ; ++j){
					calcCheckSum[index++] =  sheetCheckSum[2][j];
				}
			
			}
		
			return calcCheckSum;
		}
	private boolean[] answerFirstRowGrey =
		 {false,true,false,false,true,false,true,false,true,false};
	
	private int getIndex(char c){
			return c - 'A';
	}
	private boolean isGreyField(int questionNum, char answerLetter){
		// does the number is odd ? 
		int ans = questionNum%2;
		boolean res = answerFirstRowGrey[getIndex(answerLetter)];
		
		if(ans == 1){ // as first line
			return res;
		}
		return !res;
	}

}
