/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.model.testscrambler;

import java.util.ArrayList;

import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class ScrambleHashEntry {
		private String parentCategoryName;
		private ArrayList versionsOfCategory = new ArrayList();
		private ArrayList childCategories = new ArrayList();
		/**
		 * Method ScrambleHashEntry
		 * @param parent
		 */
		public ScrambleHashEntry(String parent) {
			this.parentCategoryName = parent;
		}
		/**
		 * Method addVersion
		 * @param tv
		 */
		public void addVersion(TestVersion tv) {
			versionsOfCategory.add(tv);
		}
		/**
		 * Method addChildCategory
		 * @param childName
		 */
		public void addChildCategory(String childName) {
			if (!childCategories.contains(childName))
				childCategories.add(childName);
		}
		/**
		 * Method getVersions
		 * @return ArrayList
		 */
		public ArrayList getVersions(){
			return versionsOfCategory;
		}
		/**
		 * Method setVersions
		 * @param a
		 */
		public void setVersions(ArrayList a){
			versionsOfCategory = a;
		}
		
		/**
		 * Method setChildren
		 * @param a
		 */
		public void setChildren(ArrayList a){
			childCategories = a;
		}
		
		/**
		 * Method getChildren
		 * @return ArrayList
		 */
		public ArrayList getChildren(){
			return childCategories;
		}
	}