/*
 * Created on 06/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;


import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type CategoryGetFullPath
 * @author sybenny
 * @version 1.0
 */
public class CategoryGetFullPath extends ScriptCommand {
	
	/**
	 * Method CategoryGetFullPath
	 */
	public CategoryGetFullPath(){
		usage = "Should be: categoryGetFullPath"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException{
		assertMaxParams(0);		
		Category c = CommandDispatcher.getInstance().getCurrentCategory();
		if (c==null) {throw new 
			RetriableException("Can't execute - no current category defined");
		} 
		MedReporter.report(c.getFullName());
	}

}
