/*
 * Created on 06/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type CategorySetComment
 * @author sybenny
 * @version 1.0
 */
public class CategorySetComment extends ScriptCommand {
	
	/**
	 * Method CategorySetComment
	 */
	public CategorySetComment(){
		usage = "Should be: categorySetComment \"newComment\""; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {	
		String newComment;

		assertMaxParams(1);		
		if (!paramExists(0))	
			params.add(0,MedScript.askMissingParameter("newComment", usage));
		newComment = extractString((String)params.get(0),"newComment");

		Command c = new il.ac.technion.cs.course236308.e3.med.command.category.
												CategorySetComment(newComment);
		CommandDispatcher.getInstance().run(c);
	}
}
