/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;
import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;


/**
 * Type CategorySetParent
 * @author sybenny
 * @version 1.0
 */
public class CategorySetParent extends ScriptCommand{
	/**
	 * Method CategorySetParent
	 */
	public CategorySetParent() {
		usage = "Should be: categorySetParent newParentId";
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException{
		int newParentId;
		assertMaxParams(1);		
		if (!paramExists(0)) {
			params.add(0,MedScript.askMissingParameter("newParentId", usage));
		}
		newParentId = extractInt((String)params.get(0),"newParentId");
		Command c = new il.ac.technion.cs.course236308.e3.med.command.
								category.CategorySetParent(newParentId);
		CommandDispatcher.getInstance().run(c);
	}
}
