/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestExport
 * @author sybenny
 * @version 1.0
 */
public class TestExport extends ScriptCommand {
	private static final String[] OPTIONS = {"append","replace","abort"};
	/**
	 * Method TestExport
	 */
	public TestExport (){
		usage = "Should be: testExport \"filename\" mode"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {
		
		String filename;
		int mode;
		
		assertMaxParams(2);				
		if (!paramOfType(0,STRING)) 
			params.add(0,MedScript.askMissingParameter("filename", usage));			
		filename = extractString((String)params.get(0),"filename");

		if (!paramExists(1))
			params.add(1,MedScript.askMissingParameter("mode", usage));	
		mode = extractByList((String)params.get(1),OPTIONS,"mode");				
		
		Command c = new il.ac.technion.cs.course236308.e3.med.command.
											test.TestExport(filename, mode);
		CommandDispatcher.getInstance().run(c);
	}

}
