/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;


import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestGetFactor
 * @author sybenny
 * @version 1.0
 */
public class TestGetFactor extends ScriptCommand {
	
	/**
	 * Method TestGetFactor
	 */
	public TestGetFactor(){
		usage = "Should be: testGetFactor"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException{	
		assertMaxParams(0);				
		Test t = CommandDispatcher.getInstance().getCurrentTest();
		if (t==null) {throw new 
			RetriableException("Can't execute - no current test defined");} 
		double factA = t.getFactorConstA();
		double factB = t.getFactorConstB();
		MedReporter.report((new Double(factA)).toString());
		MedReporter.report((new Double(factB)).toString());
	}
}
