/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;


import java.util.Iterator;
import java.util.TreeSet;

import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestGetVersions
 * @author sybenny
 * @version 1.0
 */
public class TestGetVersions extends ScriptCommand {
	
	/**
	 * Method TestGetVersions
	 */
	public TestGetVersions(){
		usage = "Should be: testGetVersions"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException {	
		assertMaxParams(0);				
		Test t = CommandDispatcher.getInstance().getCurrentTest();
		if (t==null) {throw new
			 RetriableException("Can't execute - no current test defined");} 
		TreeSet idSet = new TreeSet();
		for(Iterator it = t.getTestVersions().iterator();it.hasNext();){
			TestVersion tv = (TestVersion)it.next();
			idSet.add(new Integer(tv.getVersion().getId()));
		}
		for(Iterator it = idSet.iterator(); it.hasNext();){
			MedReporter.report(((Integer)it.next()).toString());
		}
	}

}
