/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestSetFactor
 * @author sybenny
 * @version 1.0
 */
public class TestSetFactor extends ScriptCommand {
	/**
	 * Method TestSetFactor
	 */
	public TestSetFactor(){
		usage = "Should be: testSetFactor newFactorA newFactorB";  
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {
		
		double newFactorA, newFactorB;
		
		assertMaxParams(2);				
		if (!paramOfType(0,DOUBLE)) 
			params.add(0,MedScript.askMissingParameter("newFactorA", usage));			
		newFactorA = extractDouble((String)params.get(0),"newFactorA");
		
		if (!paramExists(1)) 
			params.add(1,MedScript.askMissingParameter("newFactorB", usage));	
		newFactorB = extractDouble((String)params.get(1),"newFactorB");				
			
		Command c = new il.ac.technion.cs.course236308.e3.med.command.test.
										TestSetFactor(newFactorA, newFactorB);
		CommandDispatcher.getInstance().run(c);
	}

}