/*
 * Created on Jun 5, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.stats;

import java.util.HashMap;

import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;




/**
 * @author ssdl-103
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class StatisticData {
	
    private HashMap testHash = new HashMap(); //testId -> QuestionStats
    private static StatisticData instance = new StatisticData();
    public static StatisticData getInstance(){
        return instance;
    }
    private StatisticData(){}
    
    public QuestionsStats getQuestionsStats(int testId) {
    	return (QuestionsStats)testHash.get(new Integer(testId));
    }
    
    public void updateQuestionsStatistics(int testId) throws RetriableException, CriticalException{
    	if (GeneralParams.scriptMode) return;
		updateQuestionsStatisticsDontUpdateDB(testId);
      	StatsUpdateDB.getInstance().update(testId);
    }
	public void updateQuestionsStatisticsDontUpdateDB(int testId) throws RetriableException, CriticalException{
		if (GeneralParams.scriptMode) return;
		StudentsStats ss = updateStudentStatistics(testId);
		QuestionsStats questionStatistics = new QuestionsStats(testId, ss);
		testHash.put(new Integer(testId),questionStatistics);   		
	}
	
    private StudentsStats updateStudentStatistics(int testId) throws RetriableException, CriticalException{
    	StudentsStats studentStatistics = new StudentsStats(testId);
        studentStatistics.updateGradingTable();
        return studentStatistics;
    }
    
}
