/*
 * QuestionSelect.java
 * 
 *  Created on 24/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;


/**
 * @author svekant
 *
 */
public class QuestionDeleteIllegalObject extends Command{
	
	private Question question = null;

	/**
	 * Method QuestionSelect
	 * @param question
	 */
	public QuestionDeleteIllegalObject(Question question){
		 this.question = question;
	}

	/**
	 * Method execute
	 * @throws CriticalException
	 * @throws RetriableException
	 * @throws CriticalException
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		CommandDispatcher.getInstance().checkQuestionLegality(question);
		CommandDispatcher.getIllegalObjects().remove(question);
	}
	
	/**
	 * Method undo
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException{
		CommandDispatcher.getInstance().checkQuestionLegality(question);
	}
}
