/*
 * Created on 24/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Version;
/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class VersionDeleteIllegalObject extends Command {
	
	private Version version = null;

	/**
	 * Method VersionSelect
	 * @param version
	 */
	public VersionDeleteIllegalObject(Version version){
		 this.version = version;
	}

	/**
	 * Method execute
	 * @throws CriticalException
	 * @throws RetriableException
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException{
		CommandDispatcher.getInstance().checkVersionLegality(version);
		CommandDispatcher.getIllegalObjects().remove(version);
	}
	
	/**
	 * Method undo
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException{
		CommandDispatcher.getInstance().checkVersionLegality(version);
	}

}
