/*
 * Created on 18/07/2004
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.test;

import il.ac.technion.cs.course236308.e3.med.command.test.answer.TestAnswerUpdateWeight;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswersFactory;

/**
 * @author shralex
 */
public class TestSetAnswerWeight extends CommandAction {
    private int testId;
    private int answerId;
    private byte weight;
    public TestSetAnswerWeight (int testId,int answerId,byte weight, MainWindow frame) {
        super("TestVersion Set weight");
        putValue(SHORT_DESCRIPTION, "TestVersion Set weight");
        init(frame);
        this.testId = testId;
        this.answerId = answerId;
        this.weight = weight;
    } 
    
    public void execute() throws RetriableException, CriticalException {
    	TestAnswer ta = TestAnswersFactory.getInstance().getTestAnswer(testId,answerId);
        runCommand(new TestAnswerUpdateWeight(ta, weight));
    }   
}
