/*
 * Created on 18/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.db.queries.grading;

import il.ac.technion.cs.course236308.e3.med.db.Query;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Test;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class PercentTestAnswerOfVersionReplies extends Query {
	/**
	 * Percent of student who choosed Test Answer 
	 * out of all Test Takers who answered to the version, 
	 * which the answer belongs to.
	 * @param test
	 * @param ans
	 */
	public PercentTestAnswerOfVersionReplies(Test test,Answer ans) {
		super("SELECT" +
				"(SELECT count(ExamTakerID)" +
				" FROM" +
					" (Select distinct ExamTakerID" +
					" from ExamReplies er" +
					" WHERE er.ExamID = "+test.getId()+
					" AND er.AnswerID = " + ans.getId() + " ))"+ 
		   		"/ count(ExamTakerID)" + 
				" FROM"+
 				" (select distinct ExamTakerID" +
 				" from ExamReplies er" +
				" WHERE er.AnswerID in" +
					" (select ID" +
					" from Answer" +
					" where VersionID in" +
							" (SELECT VersionID" +
							" from Answer WHERE ID=" + ans.getId() +"))"+
							" AND er.ExamID =" + test.getId()+  ")");
	}
}
