/*
 * Created on 18/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.db.queries.grading;

import il.ac.technion.cs.course236308.e3.med.db.Query;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestTakerGrade extends Query {
	/**
	 * Return TestTaker Grade
	 * @param tt
	 */
	public TestTakerGrade(TestTaker tt) {
		super("SELECT iif(ffGrade<MinGrade,MinGrade,ffGrade) AS TheGrade," +
				" iif(FinalGrade>MaxGrade,MaxGrade,FinalGrade) AS ffGrade," +
				" ExamTaker.ID," + 
				" ExamTaker.Name," + 
				" Exam.ID," +
				" Exam.PassingGrade," +
 				" (Sum(ExamAnswers.Weight*ExamVersions.Weight/100))" +
 				" /(SELECT sum(Weight)" +
 					" FROM ExamVersions" +
 					" WHERE ExamID = Exam.ID) AS RawGrade," +
					" ((RawGrade*(MaxGrade-MinGrade))+MinGrade) " +
					"AS PreFactorGrade,"+ 
					" (PreFactorGrade*FactorConstA+FactorConstB) " +
					"AS FinalGrade "+ 					
					" FROM (ExamTaker INNER JOIN ExamReplies " +
					"ON ExamTaker.ID = " +
					"ExamReplies.ExamTakerID)"+ 
					" INNER JOIN ((Exam INNER JOIN (Answer INNER JOIN " +
					"ExamAnswers ON Answer.ID = ExamAnswers.AnswerID) " +
					"ON Exam.ID = ExamAnswers.ExamID)" + 
					" INNER JOIN ExamVersions ON " +
					"(Exam.ID = ExamVersions.ExamID) " +
					"AND (Answer.VersionID = ExamVersions.VersionID))" +
					" ON (ExamReplies.AnswerID = Answer.ID) AND " +
					"(ExamReplies.ExamID = Exam.ID)"+
					" WHERE Exam.ID = "+ tt.getTestId() +
					" AND ExamTaker.ID = '"+tt.getId() + "'" +
					" GROUP BY ExamTaker.ID," +
					" ExamTaker.Name," +
					" Exam.ID," +
					" Exam.MinGrade," +
					" Exam.MaxGrade," +
					" Exam.PassingGrade, Exam.FactorConstA, Exam.FactorConstB");
	}
}
