/*
 * Created on 18/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.db.queries.test.answer;

import il.ac.technion.cs.course236308.e3.med.db.Query;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class GetTestAnswersOfVersion extends Query {
	/**
	 * Method GetTestAnswersOfVersion
	 * @param testVer
	 */
	public GetTestAnswersOfVersion(TestVersion testVer) {
		super("select AnswerID" +
				" from ExamAnswers ea, Answer a" +
				" where ea.AnswerID=a.ID" +
				" AND a.VersionID=" + testVer.getVersion().getId() +
				" AND ExamID=" + testVer.getTestId() );
	}
}
