/*
 * Created on 18/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.db.queries.version;

import java.text.SimpleDateFormat;

import il.ac.technion.cs.course236308.e3.med.db.Query;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class StoreVersion extends Query {
	/**
	 * Method StoreVersion
	 * @param quest
	 * @param ver
	 */
	public StoreVersion(Question quest,Version ver) {
		super("insert into Version (ID,QuestionID,CorrectAnswerId" +
				",Body" +
				",Language" +
				",Notes" +
				",Created" +
				",Updated" +
				",AvgDifficulty" +
				",AvgDI) values (" + 
				ver.getId() + 
				"," +quest.getId() + 
				"," + ver.getCorrectAnswerId()+
				"," + quote(ver.getBody()) +
				"," + quote(ver.getLanguage()) +
				"," + quote(ver.getNotes()) + 
				"," + quote(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").
				format(ver.getCreated().getTime())) +
				"," + quote(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").
				format(ver.getUpdated().getTime())) +
				","+ ver.getAvgDifficulty() + 
				"," + ver.getAvgDI() + ")");
	}
}
