/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type CategoryCreate
 * @author sybenny
 * @version 1.0
 */
public class CategoryCreate extends ScriptCommand {
	
	/**
	 * Method CategoryCreate
	 */
	public CategoryCreate(){
		usage = "Should be: categoryCreate \"name\""; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {	
		String name;
		assertMaxParams(1);		
		if (!paramExists(0))	
			params.add(0,MedScript.askMissingParameter("name", usage));
			
		name = extractString((String)params.get(0),"name");
		Command c = new il.ac.technion.cs.course236308.e3.med.command.
											category.CategoryCreate(name);
		CommandDispatcher.getInstance().run(c);
	}

}