/*
 * Created on 06/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type CategoryDelete
 * @author sybenny
 * @version 1.0
 */
public class CategoryDelete extends ScriptCommand {
	private static final String[] OPTIONS = {"move","delete","abort"};
	/**
	 * Method CategoryDelete
	 */
	public CategoryDelete (){
		usage = "Should be: categoryDelete questionHandling"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {
		
		int questionHandling;
		
		assertMaxParams(1);				
		if (!paramExists(0)) 
			params.add(0,MedScript.
				askMissingParameter("questionHandling", usage));			
		questionHandling = 
			extractByList((String)params.get(0),OPTIONS,"questionHandling");				
		
		Command c = new il.ac.technion.cs.course236308.e3.med.command.
								category.CategoryDelete(questionHandling);
		CommandDispatcher.getInstance().run(c);
	}

}
