/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;
import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;


/**
 * Type CategorySelect
 * @author sybenny
 * @version 1.0
 */
public class CategorySelect extends ScriptCommand{
	/**
	 * Method CategorySelect
	 */
	public CategorySelect() {
		usage = "Should be: categorySelect id";
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException{
		int id;
		assertMaxParams(1);		
		if (!paramExists(0)) {
			params.add(0,MedScript.askMissingParameter("id", usage));
		}
		id = extractInt((String)params.get(0),"id");
		Command c = new il.ac.technion.cs.course236308.e3.med.command.
												category.CategorySelect(id);
		CommandDispatcher.getInstance().run(c);
	}
}
