/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type CategorySetName
 * @author sybenny
 * @version 1.0
 */
public class CategorySetName extends ScriptCommand {
	
	/**
	 * Method CategorySetName
	 */
	public CategorySetName(){
		usage = "Should be: CategorySetName \"newName\""; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {	
		String newName;
		assertMaxParams(1);		
		if (!paramExists(0))	
			params.add(0,MedScript.askMissingParameter("newName", usage));
			
		newName = extractString((String)params.get(0),"newName");
		Command c = new il.ac.technion.cs.course236308.e3.med.command.
										category.CategorySetName(newName);
		CommandDispatcher.getInstance().run(c);
	}
}
