/*
 * Created on 06/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type CategorySetOrdinal
 * @author sybenny
 * @version 1.0
 */
public class CategorySetOrdinal extends ScriptCommand {
	
	/**
	 * Method CategorySetOrdinal
	 */
	public CategorySetOrdinal(){
		usage = "Should be: categorySetOrdinal newOrdinal"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {	
		int newOrdinal;
		assertMaxParams(1);		
		if (!paramExists(0))	
			params.add(0,MedScript.askMissingParameter("newOrdinal", usage));
			
		newOrdinal = extractInt((String)params.get(0),"newOrdinal");
		Command c =
			 new il.ac.technion.cs.course236308.e3.med.command.
			 			category.CategorySetOrdinal((byte)newOrdinal);
		CommandDispatcher.getInstance().run(c);
	}

}
