/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.text.SimpleDateFormat;

import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestGetDate
 * @author sybenny
 * @version 1.0
 */
public class TestGetDate extends ScriptCommand {
	
	/**
	 * Method TestGetDate
	 */
	public TestGetDate(){
		usage = "Should be: testGetDate"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException{
		assertMaxParams(0);			
		Test t = CommandDispatcher.getInstance().getCurrentTest();
		if (t==null) {throw new 
			RetriableException("Can't execute - no current test defined");} 
		if (t.getDate()==null) {
			MedReporter.report("null");
			return;
		} 
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		MedReporter.report(sdf.format(t.getDate().getTime()));
	}

}