/*
 * Created on 06/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestImportAnswers
 * @author sybenny
 * @version 1.0
 */
public class TestImportAnswers extends ScriptCommand {
	
	/**
	 * Method TestImportAnswers
	 */
	public TestImportAnswers(){
		usage = "Should be: testImportAnswers \"filename\""; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {	
		String filename;
		assertMaxParams(1);			
		if (!paramExists(0))	
			params.add(0,MedScript.askMissingParameter("filename", usage));
		filename = extractString((String)params.get(0),"filename");

		Command c = new il.ac.technion.cs.course236308.e3.med.command.grading.
													TestImportAnswers(filename);
		CommandDispatcher.getInstance().run(c);
	}

}