/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestSetGradeRange
 * @author sybenny
 * @version 1.0
 */
public class TestSetGradeRange extends ScriptCommand {
	/**
	 * Method TestSetGradeRange
	 */
	public TestSetGradeRange(){
		usage = 
		"Should be: testSetGradeRange newMinGrade newMaxGrade newPassingGrade";  
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {
		
		int newMinGrade, newMaxGrade, newPassingGrade;
		
		assertMaxParams(3);				
		if (!paramOfType(0,INTEGER)) 
			params.add(0,MedScript.askMissingParameter("newMinGrade", usage));			
		newMinGrade = extractInt((String)params.get(0),"newMinGrade");
		
		if (!paramOfType(1,INTEGER)) 
			params.add(1,MedScript.askMissingParameter("newMaxGrade", usage));	
		newMaxGrade = extractInt((String)params.get(1),"newMaxGrade");				
		
		if (!paramExists(2)) 
			params.add(2,MedScript.
					askMissingParameter("newPassingGrade", usage));	
		newPassingGrade = extractInt((String)params.get(2),"newPassingGrade");				
			
		Command c =
			 new il.ac.technion.cs.course236308.e3.med.command.test.
			 	TestSetGradeRange(newMinGrade,newMaxGrade, newPassingGrade);
		CommandDispatcher.getInstance().run(c);
	}

}
