/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.version;


import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type VersionGetId
 * @author sybenny
 * @version 1.0
 */
public class VersionGetId extends ScriptCommand {
	
	/**
	 * Method VersionGetId
	 */
	public VersionGetId(){
		usage = "Should be: versionGetId"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException {	
		assertMaxParams(0);				
		Version v = CommandDispatcher.getInstance().getCurrentVersion();
		if (v==null) {throw new 
			RetriableException("Can't execute - no current version defined");} 
		MedReporter.report(String.valueOf(v.getId()));

	}
}
