/*
 * Created on Apr 22, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.stats;

import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

import java.util.*;



/**
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class GradingTableItem {

	private TestVersion testVersion;
    private double questionWeight; 
    private HashMap answerList; // (Integer answerId,Byte weight)
    private int rightAnswer; // id of correct answer

     public GradingTableItem(TestVersion tv) {
       answerList = new HashMap();
       testVersion = tv;
       questionWeight = tv.getWeight().doubleValue();
       // Fill m_AnswerList(answer=>weight) and m_RightAnswer
      
       for (Iterator it = tv.getTestAnswers().iterator(); it.hasNext();){
           TestAnswer currAns = (TestAnswer)it.next();
           Byte weight = new Byte(currAns.getWeight());
           answerList.put(new Integer(currAns.getAnswerId()),weight); 
       }
       rightAnswer = tv.getVersion().getCorrectAnswerId();
    }
    
    public byte getAnswerWeight(Integer ansId){
    	return ((Byte)answerList.get(ansId)).byteValue();
    }
    public HashMap getAnswerHash(){
    	return answerList;
    }
	public TestVersion getTestVersion(){
		return testVersion;
	}
	
	public double getQuestionWeight(){
		return questionWeight;
	}
	
    public int getRightAnswer() {
         return rightAnswer;
     }

     public void setRightAnswer(int answer){
         rightAnswer = answer;
     }
}
