<?xml version="1.0" encoding="WINDOWS-1255"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="xml" indent="yes"/>
<xsl:template match="/">
  <html>
  <head></head>
  <body>
     <span style="font-size:20px;">
     	<h1 ALIGN="center"><xsl:value-of select = "tests/test/courseName"/>
     	<br></br>
     	<xsl:value-of select = "tests/test/description1"/>
	<br></br>
	<xsl:value-of select = "tests/test/description2"/></h1>
	<br></br>
	<h3 align="center"><xsl:text>Exam Date: </xsl:text><xsl:value-of select = "substring(tests/test/date,0,11)"/></h3>
     </span>
     <br></br>
     <H3 ALIGN="center">Instructions: <xsl:copy-of select = "tests/test/instructions"/></H3>
     <br/><br/><br/>
     
     <xsl:for-each select="tests/test/testVersion">
     <P><xsl:attribute name="dir"><xsl:value-of select="./body/@dir"/></xsl:attribute>
	<xsl:variable name="fn" select="@mainCategory"/>
	<xsl:if test= "not(preceding-sibling::*/@mainCategory=$fn)">
		[<xsl:value-of select="@mainCategory"/>]
	</xsl:if>
	<TABLE>
	<TR><TD>
		<xsl:value-of select="position()"/>. 
		<xsl:copy-of select="./body" />
	</TD></TR>
	<TR><TD>
	<ol type="A">
        <xsl:for-each select="answer">
	    <xsl:if test = "@correct='true'">
	      <span style="color: blue; font-size:20px;">
		<li>	
					
			<xsl:for-each select="text">
				<xsl:copy-of select="." />
			</xsl:for-each>
			
		</li>
 	       </span>
	    </xsl:if>
	    <xsl:if test = "@correct!='true'">
	      <span style="color: black;">
		<li>
			<xsl:for-each select="text">
				<xsl:copy-of select="." />
			</xsl:for-each>
		</li>
 	       </span>
	    </xsl:if> 
        </xsl:for-each>
	</ol>
	</TD></TR>
	</TABLE>
     </P>
     </xsl:for-each>
     </body>
     </html>
</xsl:template>
</xsl:stylesheet>
